package it.unitn.disi.prog2.esameluglio18;

import it.unitn.disi.prog2.esameluglio18.figures.Circle;
import it.unitn.disi.prog2.esameluglio18.figures.Hexagon;
import it.unitn.disi.prog2.esameluglio18.figures.Triangle;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.TilePane;

/** 
 * pannello che permette la scelta della figura desiderata
 **/
public class ChoicePanel extends TilePane{
    Stack stack=null;
    StackPane centralPane=null;
    Button circleButton=new Button("Circle");
    Button hexagonButton=new Button("Hexagon");
    Button triangleButton=new Button("Triangle");
    public ChoicePanel(Stack stack, StackPane centralPane) {
        this.centralPane=centralPane;
        this.stack=stack;
        this.setPrefColumns(3);
        this.setPrefRows(1);
        circleButton.setPrefWidth(80);
        hexagonButton.setPrefWidth(80);
        triangleButton.setPrefWidth(80);
        circleButton.setOnAction(new ChoicePanel.CircleButtonListener());
        hexagonButton.setOnAction(new ChoicePanel.HexagonButtonListener());
        triangleButton.setOnAction(new ChoicePanel.TriangleButtonListener());
        this.getChildren().add(circleButton);
        this.getChildren().add(triangleButton);
        this.getChildren().add(hexagonButton);
    }
    // inner classes per gli ascoltatori
    // Nota: ci sono due implementazioni, una con
    // setNextFiguraType(Class)
    // e l'altra con 
    // setNextFiguraType(String)
    // fanno riferimento ai rispettivi metodi della classe Stack
    // e sono alternative tra loro
    // decommentare quella voluta, e commentare l'altra
    private class CircleButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
            stack.setNextFiguraType(Circle.class);
            stack.setNextFiguraType("Cerchio");
            centralPane.getChildren().remove(0);
            centralPane.getChildren().add(new Circle().getNode());
            triangleButton.setDisable(false);
            hexagonButton.setDisable(false);
            circleButton.setDisable(true);
        }   
    }
    private class TriangleButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
            stack.setNextFiguraType(Triangle.class);
            stack.setNextFiguraType("Triangolo");
            centralPane.getChildren().remove(0);
            centralPane.getChildren().add(new Triangle().getNode());
            triangleButton.setDisable(true);
            hexagonButton.setDisable(false);
            circleButton.setDisable(false);
        }   
    }    
    private class HexagonButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
            stack.setNextFiguraType(Hexagon.class);
            stack.setNextFiguraType("Esagono");
            centralPane.getChildren().remove(0);
            centralPane.getChildren().add(new Hexagon().getNode());
            triangleButton.setDisable(false);
            hexagonButton.setDisable(true);
            circleButton.setDisable(false);
        }   
    }
}
