package it.unitn.disi.prog2.esameluglio18;

import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.layout.TilePane;
/** 
 * pannello che contiene i bottoni con le azioni possibili
 **/
public class ControlPane extends TilePane{
    Stack stack=null;
    Button addButton=new Button("Add");
    Button printStackButton=new Button("Print Stack");
    Button removeBottomButton=new Button("Remove Bottom");
    Button removeTopButton=new Button("Remove Top");
    public ControlPane(Stack stack) {
        this.stack=stack;
        this.setPrefColumns(2);
        this.setPrefRows(2);
        addButton.setPrefWidth(120);
        printStackButton.setPrefWidth(120);
        removeBottomButton.setPrefWidth(120);
        removeTopButton.setPrefWidth(120);
        addButton.setOnAction(new AddButtonListener());
        removeBottomButton.setOnAction(new RemoveBottomButtonListener());
        removeTopButton.setOnAction(new RemoveTopButtonListener());
        printStackButton.setOnAction(new PrintStackButtonListener());
        this.getChildren().add(addButton);
        this.getChildren().add(removeBottomButton);
        this.getChildren().add(removeTopButton);
        this.getChildren().add(printStackButton);
    }
    // inner classes per gli ascoltatori
    private class AddButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
            stack.addFigura();
        }   
    }
    private class RemoveBottomButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
            stack.removeBottom();
        }   
    }
    private class RemoveTopButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
             stack.removeTop();
        }   
    }
    private class PrintStackButtonListener implements EventHandler<ActionEvent>{
        @Override
        public void handle(ActionEvent event) {
             stack.printContent();
        }   
    }
}
